
# Ehssen Betaieb, MATSPIF-ID 20-09-2020


import os,subprocess,time,shutil,sys
import numpy as np

# User-adapted
Extension = 'ipe'  # Result file extension
Acceptance_Value = 0.1 # Acceptable error (1 for big test and 0.1 for small test)

# Reference simulation path (Standard for all the tests)
Directory = os.getcwd()
Simulation_Path = Directory+'\\'
Test_name = os.path.basename(Directory)
Ref_Simulation_Path = Directory+'\\'+Test_name+'_ref\\'
Comparison_File = Test_name+'.'+ Extension



# Read the reference file and find last (User-adapted)
Ref_File_Path = Ref_Simulation_Path+Comparison_File
with open(Ref_File_Path, 'r') as file:
      Content_Ref = file.read().splitlines()

Time_Res = [0]*(len(Content_Ref)-1)
Elem_Res = [0]*(len(Content_Ref)-1)
Value_Ref_S1 = [0]*(len(Content_Ref)-1)
Value_Ref_Def3 = [0]*(len(Content_Ref)-1)
Value_Ref_Def1 = [0]*(len(Content_Ref)-1)

for i in range(1,len(Content_Ref)-1):
    Time_Res[i] = (Content_Ref[i].split()[2])
    Elem_Res[i] = (Content_Ref[i].split()[3])
    Value_Ref_S1[i] = (Content_Ref[i].split()[9])
    Value_Ref_Def3[i] = (Content_Ref[i].split()[12])
    Value_Ref_Def1[i] = (Content_Ref[i].split()[15])


# Read the result file and find last value (User-adapted)

Res_File_Path = Simulation_Path+Comparison_File
with open(Res_File_Path, 'r') as file:
      Content_Res = file.read().splitlines()

Time_Res = [0]*(len(Content_Res)-1)
Elem_Res = [0]*(len(Content_Res)-1)
Value_Res_S1 = [0]*(len(Content_Res)-1)
Value_Res_Def3 = [0]*(len(Content_Res)-1)
Value_Res_Def1 = [0]*(len(Content_Res)-1)

for i in range(1,len(Content_Res)-1):
    Time_Res[i] = (Content_Res[i].split()[2])
    Elem_Res[i] = (Content_Res[i].split()[3])
    Value_Res_S1[i] = (Content_Res[i].split()[9])
    Value_Res_Def3[i] = (Content_Res[i].split()[12])
    Value_Res_Def1[i] = (Content_Res[i].split()[15])


# Error Calculation (User-adapted)


Error_S1 = 0
Error_Def3 = 0
Error_Def1 = 0
for i in range(1,len(Value_Res_S1)):
        Error_S1 = ((abs(float(Value_Ref_S1[i]) - float(Value_Res_S1[i])))/(abs(float(Value_Ref_S1[i]))))
for i in range(1,len(Value_Res_Def3)):
    if float(Value_Ref_Def3[i])!=0:
    	Error_Def3 = ((abs(float(Value_Ref_Def3[i]) - float(Value_Res_Def3[i])))/(abs(float(Value_Ref_Def3[i]))))
for i in range(1,len(Value_Res_Def1)):
    if float(Value_Ref_Def1[i])!=0:
    	Error_Def1 = ((abs(float(Value_Ref_Def1[i]) - float(Value_Res_Def1[i])))/(abs(float(Value_Ref_Def1[i]))))

Error = (Error_S1 + Error_Def3 + Error_Def1)/3
Rep_File_Path = Simulation_Path+Test_name+'.rep'
with open(Rep_File_Path, 'w') as file:
      file.write('Error =  '+str(Error)+' %'+'\n')
      if Error < Acceptance_Value:
              file.write('Success')
      else:
              file.write('Failure')


